<?php

namespace FiloBlu\Referrals\Plugin;


use FiloBlu\Referrals\Helper\Core;
use FiloBlu\Referrals\Helper\Rule;

class UtilityPlugin
{
    /**
     * @var Rule
     */
    protected $ruleHelper;
    /**
     * @var Core
     */
    protected $referralHelper;

    public function __construct(
        Core $referralHelper,
        Rule $ruleHelper
    )
    {
        $this->ruleHelper = $ruleHelper;
        $this->referralHelper = $referralHelper;
    }

    /*
     * This is needed because ONLY the user receiving a coupon from an invite can use THAT coupon
     * That coupon is not shareable!
     */
    public function afterCanProcessRule($utility, $result, $rule, $address){

        //check if module is active
        if (!$this->referralHelper->isEnabled()){
            return $result;
        }

        //check if coupon was used yet
        $coupon = $this->referralHelper->getCuponInfo($rule->getCode());
        if ($coupon->getTimesUsed() > 0) {
            return $result;
        }

        //check if current cuopon is a referrall coupon
        if (!$this->ruleHelper->canApplyRule($rule)) {
            return $result;
        }

        return true;
    }
}